︠8b33efbe-5f3a-44f3-acfc-b62d0b557628︠
# shift enter "compiles"/runs code
A = AlphabeticStrings()
S = ShiftCryptosystem(A)
S
#K = randint(0,26)
K = 3
plaintext = S.encoding("Happy Friday YAY!!!")
plaintext
ciphertext = S.enciphering(K, plaintext)
ciphertext
m = S.deciphering(K, ciphertext)
m
︡de3e08b8-d1d0-42cb-8813-4e20bb7ab35f︡{"stdout":"Shift cryptosystem on Free alphabetic string monoid on A-Z\n"}︡{"stdout":"HAPPYFRIDAYYAY\n"}︡{"stdout":"KDSSBIULGDBBDB\n"}︡{"stdout":"HAPPYFRIDAYYAY\n"}︡{"done":true}
︠899a0c30-4123-4365-b17f-6e724003957b︠
A = AlphabeticStrings()
S = AffineCryptosystem(A)
S
a = 3; b = 13
K = (a, b)
K
plaintext = S.encoding("Let's Hang OUT!!!")
plaintext
mod(3*11 + 13, 26)
# 20 = u
ciphertext = S.enciphering(a, b, plaintext)
ciphertext
m = S.deciphering(a, b, ciphertext)
m
︡861dbbc1-6f82-4513-b851-10e32d24649c︡{"stdout":"Affine cryptosystem on Free alphabetic string monoid on A-Z\n"}︡{"stdout":"(3, 13)\n"}︡{"stdout":"LETSHANGOUT\n"}︡{"stdout":"20\n"}︡{"stdout":"UZSPINAFDVS\n"}︡{"stdout":"LETSHANGOUT\n"}︡{"done":true}
︠0466d535-36ed-427f-bab1-44aefe820fd1︠
# if
a = 8
if a > 1:
    a = a + 1
    print "yes"
else:
    a = a - 1
    print "no"
a
︡9d69364f-de30-4f40-a64f-c8ff717c27d0︡{"stdout":"yes\n"}︡{"stdout":"9\n"}︡{"done":true}
︠91cc72ba-fd49-4a1d-88be-8866756f74fd︠
# for
for i in range(26):
    print i
︡3daca32f-4a69-40a4-b9fd-50d1b7db0e6d︡{"stdout":"0\n1\n2\n3\n4\n5\n6\n7\n8\n9\n10\n11\n12\n13\n14\n15\n16\n17\n18\n19\n20\n21\n22\n23\n24\n25\n"}︡{"done":true}
︠eb30fc0e-5d02-49c2-8a70-ea4dc4a73b97︠
# while
a = 7
while (a > 0):
    a = a - 1
    print a

# function declaration
︡883532a2-ea2d-40be-96da-9b22d4da3c3e︡{"stdout":"6\n5\n4\n3\n2\n1\n0\n"}︡{"done":true}
︠325e6391-06d5-491a-855e-6ed2cfad4125︠
# sample function definition
def my_shift(K, p):
    return mod(p + K, 26)

my_shift(0, 3)
︡6f9e5774-5777-48e0-afc5-6177910611d2︡{"stdout":"3\n"}︡{"done":true}
︠85df13d0-5765-4e2a-b864-61995b5f3cab︠
# playing around with Shor's algorithm
N = 21137
m = 20
gcd(m, N)
︡2a8d67a6-5925-4fee-ac3f-266bf52f8672︡{"stdout":"1\n"}︡{"done":true}
︠ac6ce0e4-fd47-44a4-a560-ab09a01df1fes︠
P = 1
while (power_mod(m, P, N) != 1):
    P = P + 1
P
power_mod(m, P, N)
︡2774ca49-326e-4a14-8a97-1e41bb749471︡{"stdout":"10098\n"}︡{"stdout":"1\n"}︡{"done":true}
︠f08c4acb-6961-48ab-876d-ee6ecd550b3es︠
mod( power_mod(m, int(P/2), N) + 1, N )
︡8ccfabcd-f72d-444c-ad69-d9de2522354d︡{"stdout":"1840\n"}︡{"done":true}
︠cdb41d0d-8a79-4ef9-899b-86b4c98d2ac7s︠
gcd(power_mod(m, int(P/2), N) - 1, N)
︡95dacf6a-7e9e-4c76-9416-146c00bae837︡{"stdout":"919\n"}︡{"done":true}
︠94384cb3-36cd-490f-920e-c52f0cbe8171s︠
N/919
︡f8aaa841-8d05-4b9a-adca-8712b6a228af︡{"stdout":"23\n"}︡{"done":true}
︠9765929d-e1a3-4528-9d55-6d0f124f5c52︠









